KVM Unit Test
Several ways to run test cases under KUT
用 EFI 的方式来跑:
./x86/efi/run x86/intel_tdx.efi
相当于每一个源代码文件都被编成了一个 guest kernel image 比如说 x86/intel_tdx.efi
。我们可以看到在脚本文件 x86/efi/run
中:
"$TEST_DIR/run" \
-drive file="$EFI_UEFI",format=raw,if=pflash,readonly=on \
-drive file.dir="$EFI_TEST/$EFI_CASE/",file.driver=vvfat,file.rw=on,format=raw,if=virtio \
-net none \
-nographic \
-m 256 \
"$@" \
-smp "$EFI_SMP"
直接跑 binary:
需要首先 make standalone
编出来每一个特定的 binary,如此就可以直接跑 binary 了 tests/vmx
类似这样。
make standalone
其实是 call 了 scripts/mkstandalone.sh
这个脚本。
使用脚本跑:
./run_tests.sh -g tdx
这种方式比较灵活,可以直接跑一个 group。
Test group in KUT
KVM-unit-test 里有 test group 的概念,表示一组相关联的 test cases。
可以看到 x86/unittests.cfg
里大部分 test cases 都有自己的 group,而且可以同时指定多个 groups:
[vmx_pf_exception_test_fep]
file = vmx.flat
extra_params = -cpu max,+vmx -append "vmx_pf_exception_forced_emulation_test"
arch = x86_64
groups = vmx nested_exception nodefault
timeout = 240
So that a given group can be executed by specifying its name in the runner's -g option:
./run_tests.sh -g mygroup
EFI test in KUT
KUT 不仅支持传统的 bios,也支持以 EFI 的方式 load OVMF 之后进行测试。TDX 只支持 EFI 的方式。
*.flat
File in KUT
In x86/unittests.cfg
:
[vmx_vmcs_shadow_test]
file = vmx.flat
extra_params = -cpu max,+vmx -append vmx_vmcs_shadow_test
arch = x86_64
groups = vmx
timeout = 180
[vmx_pf_exception_test]
file = vmx.flat
extra_params = -cpu max,+vmx -append "vmx_pf_exception_test"
arch = x86_64
groups = vmx nested_exception
[vmx_pf_exception_test_fep]
file = vmx.flat
extra_params = -cpu max,+vmx -append "vmx_pf_exception_forced_emulation_test"
arch = x86_64
groups = vmx nested_exception nodefault
timeout = 240
上面三个 test case 的 file 都是 vmx.flat
文件,只是启动的参数不一样。From docs/unittests.txt
我们可以看到对于 file
的解释:
This parameter is mandatory and specifies which binary under the <arch>/ directory to run. Typically this is <name>.flat or <name>.elf, depending on the arch. The directory name is not included, only the file name.
可见这是一个 binary 文件。In KVM unit tests, both flat and ELF (Executable and Linkable Format) files serve as representations of the "kernel" being tested
scripts/mkstandalone.sh
#!/usr/bin/env bash
# 如果 config.mak file 不存在,那么我们需要首先 configure。
if [ ! -f config.mak ]; then
echo "run ./configure && make first. See ./configure -h"
exit 1
fi
source config.mak
source scripts/common.bash
temp_file ()
{
local var="$1"
local file="${2:--}"
echo "$var=\`mktemp\`"
echo "cleanup=\"\$$var \$cleanup\""
echo "base64 -d << 'BIN_EOF' | zcat > \$$var || exit 2"
gzip -c "$file" | base64
echo "BIN_EOF"
echo "chmod +x \$$var"
}
config_export ()
{
echo "export $(grep ^${1}= config.mak)"
}
generate_test ()
{
local args=()
for arg in "${@}"; do
args+=("$(printf "%q" "$arg")")
done
echo "#!/usr/bin/env bash"
echo "export KUT_STANDALONE=yes"
echo "export ENVIRON_DEFAULT=$ENVIRON_DEFAULT"
echo "export HOST=\$(uname -m | sed -e 's/i.86/i386/;s/arm.*/arm/;s/ppc64.*/ppc64/')"
echo "export PRETTY_PRINT_STACKS=no"
config_export ARCH
config_export ARCH_NAME
config_export PROCESSOR
echo "echo BUILD_HEAD=$(cat build-head)"
# 这个 variable 从哪里来的呢?
# kernel 就是类似于 x86/intel_tdx.flat 这种格式。
if [ ! -f $kernel ]; then
echo 'echo "skip '"$testname"' (test kernel not present)"'
echo 'exit 2'
return
fi
echo "trap 'rm -f \$cleanup' EXIT"
if [ "$FIRMWARE" ]; then
temp_file FIRMWARE "$FIRMWARE"
echo 'export FIRMWARE'
fi
if [ "$ENVIRON_DEFAULT" = "yes" ] && [ "$ERRATATXT" ]; then
temp_file ERRATATXT "$ERRATATXT"
echo 'export ERRATATXT'
fi
temp_file bin "$kernel"
# Don't want to expand $bin but print it as-is.
# shellcheck disable=SC2016
args[3]='$bin'
(echo "#!/usr/bin/env bash"
cat scripts/arch-run.bash "$TEST_DIR/run") | temp_file RUNTIME_arch_run
echo "exec {stdout}>&1"
echo "RUNTIME_log_stdout () { cat >&\$stdout; }"
echo "RUNTIME_log_stderr () { cat >&2; }"
cat scripts/runtime.bash
echo "run ${args[*]}"
}
function mkstandalone()
{
local testname="$1"
if [ -n "$one_testname" ] && [ "$testname" != "$one_testname" ]; then
return
fi
# 每一个 tests 下面的其实都是一个脚本文件而非一个二进制文件。
#
standalone=tests/$testname
generate_test "$@" > $standalone
chmod +x $standalone
echo Written $standalone.
}
# ERRATATXT 大概是一个勘误的文本文件,里面的表格记录了一些 KVM upstream 的 commits,
if [ "$ENVIRON_DEFAULT" = "yes" ] && [ "$ERRATATXT" ] && [ ! -f "$ERRATATXT" ]; then
echo "$ERRATATXT not found. (ERRATATXT=$ERRATATXT)" >&2
exit 2
fi
# enables shell scripts to respond to signals originating from system or user activity
# 删除掉 cfg 文件,如果删除失败了就退出。
trap 'rm -f $cfg' EXIT
# Shell command to create a temp file, like /tmp/tmp.w4MJpYfog4
cfg=$(mktemp)
# TEST_DIR in config.mak
unittests=$TEST_DIR/unittests.cfg
# 第一个参数是 kernel,有可能传也有可能不传
one_kernel="$1"
if [ "$one_kernel" ]; then
[ ! -f $one_kernel ] && {
echo "$one_kernel doesn't exist"
exit 1
}
# basename 本身就是一个 shell command,去除掉路径,只剩文件名。
one_kernel_base=$(basename $one_kernel)
# :- checks if ${one_kernel_base%.*} (the filename without extension) has a value.
# If it has a value (not empty), it uses that value.
one_testname="${2:-${one_kernel_base%.*}}"
if grep -q "\[$one_testname\]" $unittests; then
sed -n "/\\[$one_testname\\]/,/^\\[/p" $unittests \
| awk '!/^\[/ || NR == 1' > $cfg
else
echo "[$one_testname]" > $cfg
echo "file = $one_kernel_base" >> $cfg
fi
else
cp -f $unittests $cfg
fi
# 所有的 test 都会到这个 folder 下面
mkdir -p tests
for_each_unittest $cfg mkstandalone